# coding: utf-8

"""
    Tiledb Storage Platform API

    TileDB Storage Platform REST API  # noqa: E501

    The version of the OpenAPI document: 1.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tiledb.cloud._common.api_v2.configuration import Configuration


class AssetActivityLog(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "id": "str",
        "event_at": "datetime",
        "action": "str",
        "username": "str",
        "array_task_id": "str",
        "asset": "AssetActivityLogAsset",
    }

    attribute_map = {
        "id": "id",
        "event_at": "event_at",
        "action": "action",
        "username": "username",
        "array_task_id": "array_task_id",
        "asset": "asset",
    }

    def __init__(
        self,
        id=None,
        event_at=None,
        action=None,
        username=None,
        array_task_id=None,
        asset=None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """AssetActivityLog - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._event_at = None
        self._action = None
        self._username = None
        self._array_task_id = None
        self._asset = None
        self.discriminator = None

        self.id = id
        self.event_at = event_at
        self.action = action
        self.username = username
        if array_task_id is not None:
            self.array_task_id = array_task_id
        self.asset = asset

    @property
    def id(self):
        """Gets the id of this AssetActivityLog.  # noqa: E501

        The ID of the activity  # noqa: E501

        :return: The id of this AssetActivityLog.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AssetActivityLog.

        The ID of the activity  # noqa: E501

        :param id: The id of this AssetActivityLog.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and id is None
        ):  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def event_at(self):
        """Gets the event_at of this AssetActivityLog.  # noqa: E501

        time event took place (RFC3339)  # noqa: E501

        :return: The event_at of this AssetActivityLog.  # noqa: E501
        :rtype: datetime
        """
        return self._event_at

    @event_at.setter
    def event_at(self, event_at):
        """Sets the event_at of this AssetActivityLog.

        time event took place (RFC3339)  # noqa: E501

        :param event_at: The event_at of this AssetActivityLog.  # noqa: E501
        :type: datetime
        """
        if (
            self.local_vars_configuration.client_side_validation and event_at is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `event_at`, must not be `None`"
            )  # noqa: E501

        self._event_at = event_at

    @property
    def action(self):
        """Gets the action of this AssetActivityLog.  # noqa: E501

        type of the event  # noqa: E501

        :return: The action of this AssetActivityLog.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this AssetActivityLog.

        type of the event  # noqa: E501

        :param action: The action of this AssetActivityLog.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and action is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `action`, must not be `None`"
            )  # noqa: E501

        self._action = action

    @property
    def username(self):
        """Gets the username of this AssetActivityLog.  # noqa: E501

        User who performed action  # noqa: E501

        :return: The username of this AssetActivityLog.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this AssetActivityLog.

        User who performed action  # noqa: E501

        :param username: The username of this AssetActivityLog.  # noqa: E501
        :type: str
        """
        if (
            self.local_vars_configuration.client_side_validation and username is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `username`, must not be `None`"
            )  # noqa: E501

        self._username = username

    @property
    def array_task_id(self):
        """Gets the array_task_id of this AssetActivityLog.  # noqa: E501

        uuid of associated array task  # noqa: E501

        :return: The array_task_id of this AssetActivityLog.  # noqa: E501
        :rtype: str
        """
        return self._array_task_id

    @array_task_id.setter
    def array_task_id(self, array_task_id):
        """Sets the array_task_id of this AssetActivityLog.

        uuid of associated array task  # noqa: E501

        :param array_task_id: The array_task_id of this AssetActivityLog.  # noqa: E501
        :type: str
        """

        self._array_task_id = array_task_id

    @property
    def asset(self):
        """Gets the asset of this AssetActivityLog.  # noqa: E501


        :return: The asset of this AssetActivityLog.  # noqa: E501
        :rtype: AssetActivityLogAsset
        """
        return self._asset

    @asset.setter
    def asset(self, asset):
        """Sets the asset of this AssetActivityLog.


        :param asset: The asset of this AssetActivityLog.  # noqa: E501
        :type: AssetActivityLogAsset
        """
        if (
            self.local_vars_configuration.client_side_validation and asset is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `asset`, must not be `None`"
            )  # noqa: E501

        self._asset = asset

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetActivityLog):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetActivityLog):
            return True

        return self.to_dict() != other.to_dict()
